﻿Imports System.IO

Friend Class INIFile
    Private pairs As Dictionary(Of String, String)

    Sub New(path As String)
        Dim f As New FileInfo(path)
        pairs = loadINI(f)
    End Sub

    Private Function loadINI(f As FileInfo) As Dictionary(Of String, String)
        Dim dic As New Dictionary(Of String, String)
        If Not f.Exists Then Return dic
        Dim lines As New List(Of String)
        Using sr = f.OpenText
            Do Until sr.EndOfStream
                lines.Add(sr.ReadLine)
            Loop
        End Using
        Dim removeComment As Func(Of String, String) = Function(s)
                                                           Const commentChar = "#"c
                                                           Dim i = s.IndexOf(commentChar)
                                                           If i < 0 Then Return s
                                                           If i = 0 Then Return String.Empty
                                                           Return s.Substring(0, i)
                                                       End Function
        lines = New List(Of String)(From line In (From line In lines Select removeComment(line)) Where Not String.IsNullOrWhiteSpace(line))
        Dim parseLine As Action(Of String) = Sub(s)
                                                 Const splitChar = "="c
                                                 Dim parts() = s.Split({splitChar}, 2)
                                                 dic.Add(parts(0).Trim, parts(1).Trim.Replace("%crlf%", Environment.NewLine))
                                             End Sub
        lines.ForEach(parseLine)
        Return dic
    End Function

    Friend Function getValue(key As String) As String
        Return getValue(key, String.Empty)
    End Function

    Friend Function getValue(key As String, returnDefault As String) As String
        If pairs.ContainsKey(key) Then Return pairs(key)
        Return returnDefault
    End Function
End Class
